1#!/bin/sh
2#
3# git-submodules.sh: add, init, update or list git submodules
4#
5# Copyright (c) 2007 Lars Hjemli
6
7USAGE="[--quiet] [--cached] \
8[add <repo> [-b branch]|status|init|update|summary [-n|--summary-limit <n>] [<commit>]] \
9[--] [<path>...]"
10OPTIONS_SPEC=
11. git-sh-setup
12require_work_tree
13
14command=
15branch=
16quiet=
17cached=
18
19#
20# print stuff on stdout unless -q was specified
21#
22say()
23{
24 if test -z "$quiet"
25 then
26 echo "$@"
27 fi
28}
29
30# NEEDSWORK: identical function exists in get_repo_base in clone.sh
31get_repo_base() {
32 (
33 cd "`/bin/pwd`" &&
34 cd "$1" || cd "$1.git" &&
35 {
36 cd .git
37 pwd
38 }
39 ) 2>/dev/null
40}
41
42# Resolve relative url by appending to parent's url
43resolve_relative_url ()
44{
45 branch="$(git symbolic-ref HEAD 2>/dev/null)"
46 remote="$(git config branch.${branch#refs/heads/}.remote)"
47 remote="${remote:-origin}"
48 remoteurl="$(git config remote.$remote.url)" ||
49 die "remote ($remote) does not have a url in .git/config"
50 url="$1"
51 while test -n "$url"
52 do
53 case "$url" in
54 ../*)
55 url="${url#../}"
56 remoteurl="${remoteurl%/*}"
57 ;;
58 ./*)
59 url="${url#./}"
60 ;;
61 *)
62 break;;
63 esac
64 done
65 echo "$remoteurl/$url"
66}
67
68#
69# Map submodule path to submodule name
70#
71# $1 = path
72#
73module_name()
74{
75 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
76 re=$(printf '%s' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
77 name=$( GIT_CONFIG=.gitmodules \
78 git config --get-regexp '^submodule\..*\.path$' |
79 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
80 test -z "$name" &&
81 die "No submodule mapping found in .gitmodules for path '$path'"
82 echo "$name"
83}
84
85#
86# Clone a submodule
87#
88# Prior to calling, cmd_update checks that a possibly existing
89# path is not a git repository.
90# Likewise, cmd_add checks that path does not exist at all,
91# since it is the location of a new submodule.
92#
93module_clone()
94{
95 path=$1
96 url=$2
97
98 # If there already is a directory at the submodule path,
99 # expect it to be empty (since that is the default checkout
100 # action) and try to remove it.
101 # Note: if $path is a symlink to a directory the test will
102 # succeed but the rmdir will fail. We might want to fix this.
103 if test -d "$path"
104 then
105 rmdir "$path" 2>/dev/null ||
106 die "Directory '$path' exist, but is neither empty nor a git repository"
107 fi
108
109 test -e "$path" &&
110 die "A file already exist at path '$path'"
111
112 git-clone -n "$url" "$path" ||
113 die "Clone of '$url' into submodule path '$path' failed"
114}
115
116#
117# Add a new submodule to the working tree, .gitmodules and the index
118#
119# $@ = repo [path]
120#
121# optional branch is stored in global branch variable
122#
123cmd_add()
124{
125 # parse $args after "submodule ... add".
126 while test $# -ne 0
127 do
128 case "$1" in
129 -b | --branch)
130 case "$2" in '') usage ;; esac
131 branch=$2
132 shift
133 ;;
134 -q|--quiet)
135 quiet=1
136 ;;
137 --)
138 shift
139 break
140 ;;
141 -*)
142 usage
143 ;;
144 *)
145 break
146 ;;
147 esac
148 shift
149 done
150
151 repo=$1
152 path=$2
153
154 if test -z "$repo"; then
155 usage
156 fi
157
158 # Guess path from repo if not specified or strip trailing slashes
159 if test -z "$path"; then
160 path=$(echo "$repo" | sed -e 's|/*$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
161 else
162 path=$(echo "$path" | sed -e 's|/*$||')
163 fi
164
165 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
166 die "'$path' already exists in the index"
167
168 # perhaps the path exists and is already a git repo, else clone it
169 if test -e "$path"
170 then
171 if test -d "$path/.git" &&
172 test "$(unset GIT_DIR; cd $path; git rev-parse --git-dir)" = ".git"
173 then
174 echo "Adding existing repo at '$path' to the index"
175 else
176 die "'$path' already exists and is not a valid git repo"
177 fi
178 else
179 case "$repo" in
180 ./*|../*)
181 # dereference source url relative to parent's url
182 realrepo="$(resolve_relative_url $repo)" ;;
183 *)
184 # Turn the source into an absolute path if
185 # it is local
186 if base=$(get_repo_base "$repo"); then
187 repo="$base"
188 fi
189 realrepo=$repo
190 ;;
191 esac
192
193 module_clone "$path" "$realrepo" || exit
194 (unset GIT_DIR; cd "$path" && git checkout -q ${branch:+-b "$branch" "origin/$branch"}) ||
195 die "Unable to checkout submodule '$path'"
196 fi
197
198 git add "$path" ||
199 die "Failed to add submodule '$path'"
200
201 GIT_CONFIG=.gitmodules git config submodule."$path".path "$path" &&
202 GIT_CONFIG=.gitmodules git config submodule."$path".url "$repo" &&
203 git add .gitmodules ||
204 die "Failed to register submodule '$path'"
205}
206
207#
208# Register submodules in .git/config
209#
210# $@ = requested paths (default to all)
211#
212cmd_init()
213{
214 # parse $args after "submodule ... init".
215 while test $# -ne 0
216 do
217 case "$1" in
218 -q|--quiet)
219 quiet=1
220 ;;
221 --)
222 shift
223 break
224 ;;
225 -*)
226 usage
227 ;;
228 *)
229 break
230 ;;
231 esac
232 shift
233 done
234
235 git ls-files --stage -- "$@" | grep '^160000 ' |
236 while read mode sha1 stage path
237 do
238 # Skip already registered paths
239 name=$(module_name "$path") || exit
240 url=$(git config submodule."$name".url)
241 test -z "$url" || continue
242
243 url=$(GIT_CONFIG=.gitmodules git config submodule."$name".url)
244 test -z "$url" &&
245 die "No url found for submodule path '$path' in .gitmodules"
246
247 # Possibly a url relative to parent
248 case "$url" in
249 ./*|../*)
250 url="$(resolve_relative_url "$url")"
251 ;;
252 esac
253
254 git config submodule."$name".url "$url" ||
255 die "Failed to register url for submodule path '$path'"
256
257 say "Submodule '$name' ($url) registered for path '$path'"
258 done
259}
260
261#
262# Update each submodule path to correct revision, using clone and checkout as needed
263#
264# $@ = requested paths (default to all)
265#
266cmd_update()
267{
268 # parse $args after "submodule ... update".
269 while test $# -ne 0
270 do
271 case "$1" in
272 -q|--quiet)
273 quiet=1
274 ;;
275 --)
276 shift
277 break
278 ;;
279 -*)
280 usage
281 ;;
282 *)
283 break
284 ;;
285 esac
286 shift
287 done
288
289 git ls-files --stage -- "$@" | grep '^160000 ' |
290 while read mode sha1 stage path
291 do
292 name=$(module_name "$path") || exit
293 url=$(git config submodule."$name".url)
294 if test -z "$url"
295 then
296 # Only mention uninitialized submodules when its
297 # path have been specified
298 test "$#" != "0" &&
299 say "Submodule path '$path' not initialized"
300 continue
301 fi
302
303 if ! test -d "$path"/.git
304 then
305 module_clone "$path" "$url" || exit
306 subsha1=
307 else
308 subsha1=$(unset GIT_DIR; cd "$path" &&
309 git rev-parse --verify HEAD) ||
310 die "Unable to find current revision in submodule path '$path'"
311 fi
312
313 if test "$subsha1" != "$sha1"
314 then
315 (unset GIT_DIR; cd "$path" && git-fetch &&
316 git-checkout -q "$sha1") ||
317 die "Unable to checkout '$sha1' in submodule path '$path'"
318
319 say "Submodule path '$path': checked out '$sha1'"
320 fi
321 done
322}
323
324set_name_rev () {
325 revname=$( (
326 unset GIT_DIR
327 cd "$1" && {
328 git describe "$2" 2>/dev/null ||
329 git describe --tags "$2" 2>/dev/null ||
330 git describe --contains --tags --always "$2"
331 }
332 ) )
333 test -z "$revname" || revname=" ($revname)"
334}
335#
336# Show commit summary for submodules in index or working tree
337#
338# If '--cached' is given, show summary between index and given commit,
339# or between working tree and given commit
340#
341# $@ = [commit (default 'HEAD'),] requested paths (default all)
342#
343cmd_summary() {
344 summary_limit=-1
345 for_status=
346
347 # parse $args after "submodule ... summary".
348 while test $# -ne 0
349 do
350 case "$1" in
351 --cached)
352 cached="$1"
353 ;;
354 --for-status)
355 for_status="$1"
356 ;;
357 -n|--summary-limit)
358 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
359 then
360 :
361 else
362 usage
363 fi
364 shift
365 ;;
366 --)
367 shift
368 break
369 ;;
370 -*)
371 usage
372 ;;
373 *)
374 break
375 ;;
376 esac
377 shift
378 done
379
380 test $summary_limit = 0 && return
381
382 if rev=$(git rev-parse --verify "$1^0" 2>/dev/null)
383 then
384 head=$rev
385 shift
386 else
387 head=HEAD
388 fi
389
390 cd_to_toplevel
391 # Get modified modules cared by user
392 modules=$(git diff-index $cached --raw $head -- "$@" |
393 grep -e '^:160000' -e '^:[0-7]* 160000' |
394 while read mod_src mod_dst sha1_src sha1_dst status name
395 do
396 # Always show modules deleted or type-changed (blob<->module)
397 test $status = D -o $status = T && echo "$name" && continue
398 # Also show added or modified modules which are checked out
399 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
400 echo "$name"
401 done
402 )
403
404 test -z "$modules" && return
405
406 git diff-index $cached --raw $head -- $modules |
407 grep -e '^:160000' -e '^:[0-7]* 160000' |
408 cut -c2- |
409 while read mod_src mod_dst sha1_src sha1_dst status name
410 do
411 if test -z "$cached" &&
412 test $sha1_dst = 0000000000000000000000000000000000000000
413 then
414 case "$mod_dst" in
415 160000)
416 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
417 ;;
418 100644 | 100755 | 120000)
419 sha1_dst=$(git hash-object $name)
420 ;;
421 000000)
422 ;; # removed
423 *)
424 # unexpected type
425 echo >&2 "unexpected mode $mod_dst"
426 continue ;;
427 esac
428 fi
429 missing_src=
430 missing_dst=
431
432 test $mod_src = 160000 &&
433 ! GIT_DIR="$name/.git" git-rev-parse --verify $sha1_src^0 >/dev/null 2>&1 &&
434 missing_src=t
435
436 test $mod_dst = 160000 &&
437 ! GIT_DIR="$name/.git" git-rev-parse --verify $sha1_dst^0 >/dev/null 2>&1 &&
438 missing_dst=t
439
440 total_commits=
441 case "$missing_src,$missing_dst" in
442 t,)
443 errmsg=" Warn: $name doesn't contain commit $sha1_src"
444 ;;
445 ,t)
446 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
447 ;;
448 t,t)
449 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
450 ;;
451 *)
452 errmsg=
453 total_commits=$(
454 if test $mod_src = 160000 -a $mod_dst = 160000
455 then
456 range="$sha1_src...$sha1_dst"
457 elif test $mod_src = 160000
458 then
459 range=$sha1_src
460 else
461 range=$sha1_dst
462 fi
463 GIT_DIR="$name/.git" \
464 git log --pretty=oneline --first-parent $range | wc -l
465 )
466 total_commits=" ($(($total_commits + 0)))"
467 ;;
468 esac
469
470 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
471 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
472 if test $status = T
473 then
474 if test $mod_dst = 160000
475 then
476 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
477 else
478 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
479 fi
480 else
481 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
482 fi
483 if test -n "$errmsg"
484 then
485 # Don't give error msg for modification whose dst is not submodule
486 # i.e. deleted or changed to blob
487 test $mod_dst = 160000 && echo "$errmsg"
488 else
489 if test $mod_src = 160000 -a $mod_dst = 160000
490 then
491 limit=
492 test $summary_limit -gt 0 && limit="-$summary_limit"
493 GIT_DIR="$name/.git" \
494 git log $limit --pretty='format: %m %s' \
495 --first-parent $sha1_src...$sha1_dst
496 elif test $mod_dst = 160000
497 then
498 GIT_DIR="$name/.git" \
499 git log --pretty='format: > %s' -1 $sha1_dst
500 else
501 GIT_DIR="$name/.git" \
502 git log --pretty='format: < %s' -1 $sha1_src
503 fi
504 echo
505 fi
506 echo
507 done |
508 if test -n "$for_status"; then
509 echo "# Modified submodules:"
510 echo "#"
511 sed -e 's|^|# |' -e 's|^# $|#|'
512 else
513 cat
514 fi
515}
516#
517# List all submodules, prefixed with:
518# - submodule not initialized
519# + different revision checked out
520#
521# If --cached was specified the revision in the index will be printed
522# instead of the currently checked out revision.
523#
524# $@ = requested paths (default to all)
525#
526cmd_status()
527{
528 # parse $args after "submodule ... status".
529 while test $# -ne 0
530 do
531 case "$1" in
532 -q|--quiet)
533 quiet=1
534 ;;
535 --cached)
536 cached=1
537 ;;
538 --)
539 shift
540 break
541 ;;
542 -*)
543 usage
544 ;;
545 *)
546 break
547 ;;
548 esac
549 shift
550 done
551
552 git ls-files --stage -- "$@" | grep '^160000 ' |
553 while read mode sha1 stage path
554 do
555 name=$(module_name "$path") || exit
556 url=$(git config submodule."$name".url)
557 if test -z "$url" || ! test -d "$path"/.git
558 then
559 say "-$sha1 $path"
560 continue;
561 fi
562 set_name_rev "$path" "$sha1"
563 if git diff-files --quiet -- "$path"
564 then
565 say " $sha1 $path$revname"
566 else
567 if test -z "$cached"
568 then
569 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
570 set_name_rev "$path" "$sha1"
571 fi
572 say "+$sha1 $path$revname"
573 fi
574 done
575}
576
577# This loop parses the command line arguments to find the
578# subcommand name to dispatch. Parsing of the subcommand specific
579# options are primarily done by the subcommand implementations.
580# Subcommand specific options such as --branch and --cached are
581# parsed here as well, for backward compatibility.
582
583while test $# != 0 && test -z "$command"
584do
585 case "$1" in
586 add | init | update | status | summary)
587 command=$1
588 ;;
589 -q|--quiet)
590 quiet=1
591 ;;
592 -b|--branch)
593 case "$2" in
594 '')
595 usage
596 ;;
597 esac
598 branch="$2"; shift
599 ;;
600 --cached)
601 cached="$1"
602 ;;
603 --)
604 break
605 ;;
606 -*)
607 usage
608 ;;
609 *)
610 break
611 ;;
612 esac
613 shift
614done
615
616# No command word defaults to "status"
617test -n "$command" || command=status
618
619# "-b branch" is accepted only by "add"
620if test -n "$branch" && test "$command" != add
621then
622 usage
623fi
624
625# "--cached" is accepted only by "status" and "summary"
626if test -n "$cached" && test "$command" != status -a "$command" != summary
627then
628 usage
629fi
630
631"cmd_$command" "$@"